# generated by datamodel-codegen:
#   filename:  ingest-openapi.json
#   timestamp: 2023-02-23T15:14:43+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import List, Optional
from uuid import UUID, uuid4

from pydantic import BaseModel, Extra, Field, validator

from exceptions import EmptyListForbidden


class SuccessfulDataPushStatus(Enum):
    success = 'success'


class DataBatchStatus(Enum):
    waiting = 'waiting'
    success = 'success'
    failure = 'failure'


class ReportStatus(Enum):
    success = 'success'
    failure = 'failure'


class DataRow(BaseModel):
    class Config:
        extra = Extra.forbid
        json_encoders = {
            datetime: lambda v: v.timestamp(),
        }

    country: Optional[str] = Field(None, title='Country')
    email: str = Field(..., example='mgrigg@interchange.ubc.ca', title='Email')
    email_hash_md5_content: Optional[str] = Field(
        None, title='Email Hash Md5 Content')
    firstname: Optional[str] = Field(None, example='Mike', title='Firstname')
    lastname: Optional[str] = Field(None, example='Griffith', title='Lastname')
    ip: Optional[str] = Field(None, title='Ip')
    url: Optional[str] = Field(None, title='Url')
    date: Optional[str] = Field(None, title='Date')
    dob: Optional[str] = Field(None, title='Data of Birth')
    gender: Optional[str] = Field(None, title='Gender')
    address1: Optional[str] = Field(None, example='9112 52 ST SE',
                                    title='Address1')
    address2: Optional[str] = Field(None, title='Address1')
    zip: Optional[str] = Field(None, example='T2C 5A9', title='Zip')
    city: Optional[str] = Field(None, title='City')
    state: Optional[str] = Field(None, example='AB', title='State')
    vertical: Optional[str] = Field(None, title='Vertical')
    language: Optional[str] = Field(None, title='Language')
    phone_number1: Optional[str] = Field(
        None, example='(403) 203-0731', title='Phone Number1'
    )
    phone_number2: Optional[str] = Field(
        None, example='(905) 279-5460 x6918', title='Phone Number2'
    )
    age: Optional[int] = Field(None, title='Age')


class ColumnName(Enum):
    country = 'country'
    email = 'email'
    email_hash_md5 = 'email_hash_md5'
    firstname = 'firstname'
    lastname = 'lastname'
    ip = 'ip'
    url = 'url'
    date = 'date'
    dob = 'dob'
    gender = 'gender'
    address1 = 'address1'
    address2 = 'address2'
    zip = 'zip'
    city = 'city'
    state = 'state'
    vertical = 'vertical'
    language = 'language'
    phone_number1 = 'phone_number1'
    phone_number2 = 'phone_number2'
    age = 'age'


class Error(BaseModel):
    id: UUID = Field(..., title='Error ID')
    message: str = Field(..., title='Detail')
    code: int = Field(..., title='Status')


class Data(BaseModel):
    id: UUID = Field(default_factory=uuid4)
    status: SuccessfulDataPushStatus = Field(
        default=SuccessfulDataPushStatus.success)


class ApiV1DataPostResponse(BaseModel):
    data: Data = Field(default_factory=Data)


class ApiV1DataPostResponse1(BaseModel):
    errors: List[Error] = Field(
        ...,
        example=[
            {
                'id': '6fa85f64-5717-4562-b3fc-2c963f66afa6',
                'message': 'Authentication information is missing or invalid',
                'code': 401,
            }
        ],
    )


class ApiV1DataPostResponse2(BaseModel):
    errors: List[Error]


class ApiV1DataFeedGetResponse(BaseModel):
    data: Data = Field(default_factory=Data)


class ApiV1DataFeedGetResponse1(BaseModel):
    errors: List[Error]


class DataBatch(BaseModel):
    __root__: List[DataRow] = Field(..., description='List of data rows')

    @validator('__root__', pre=True)
    def check_if_list_has_value(cls, value):
        if not value:
            raise EmptyListForbidden('data field cannot be empty')
        return value


class ApiV1DataPostRequest(BaseModel):
    class Config:
        extra = Extra.forbid

    data: DataBatch


class ErrorResponse(BaseModel):
    errors: list[Error]
